#ifndef MENU_TREE_H
#define MENU_TREE_H

#include <map>
#include "adstring.h"

class menuentry;

bool operator<(const StrVec &left, const StrVec &right);

/*in submenu_container:
  StrVec    first   - full title, broken into a StrVec
  menuentry *second - the menu entry with this title
*/
typedef std::map<StrVec, menuentry *> submenu_container;

class menuentry {
  char hotkeyconv(char);
  void generate_hotkeys();
  void store_hints();
  StrVec section; //Do we need section? I think not. (is in parent's submenus)
  StrVec menuhints;

public:
  menuentry() : forced(false) { }

  submenu_container submenus;
  std::map<string, string> vars;
  bool forced;

  void add_entry(StrVec, std::map<string, string> &);
  void add_menuentry_ptr(StrVec s, menuentry *m);
  void output();
  void postprocess(int n_parent, int level, string title);
  void process_hints(const StrVec &pref);
  void debug(int);
};


#endif /* MENU_TREE_H */
